Kees Cook | be58f71 | 2021-04-20 23:22:52 -0700 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # SPDX-License-Identifier: GPL-2.0-only |
| 3 | set -e |
| 4 | |
| 5 | # Argument 1: Source file to build. |
| 6 | IN="$1" |
| 7 | shift |
| 8 | # Extract just the filename for error messages below. |
| 9 | FILE="${IN##*/}" |
| 10 | # Extract the function name for error messages below. |
| 11 | FUNC="${FILE#*-}" |
| 12 | FUNC="${FUNC%%-*}" |
| 13 | FUNC="${FUNC%%.*}" |
| 14 | # Extract the symbol to test for in build/symbol test below. |
| 15 | WANT="__${FILE%%-*}" |
| 16 | |
| 17 | # Argument 2: Where to write the build log. |
| 18 | OUT="$1" |
| 19 | shift |
| 20 | TMP="${OUT}.tmp" |
| 21 | |
| 22 | # Argument 3: Path to "nm" tool. |
| 23 | NM="$1" |
| 24 | shift |
| 25 | |
| 26 | # Remaining arguments are: $(CC) $(c_flags) |
| 27 | |
| 28 | # Clean up temporary file at exit. |
| 29 | __cleanup() { |
| 30 | rm -f "$TMP" |
| 31 | } |
| 32 | trap __cleanup EXIT |
| 33 | |
| 34 | # Function names in warnings are wrapped in backticks under UTF-8 locales. |
| 35 | # Run the commands with LANG=C so that grep output will not change. |
| 36 | export LANG=C |
| 37 | |
| 38 | status= |
| 39 | # Attempt to build a source that is expected to fail with a specific warning. |
| 40 | if "$@" -Werror -c "$IN" -o "$OUT".o 2> "$TMP" ; then |
| 41 | # If the build succeeds, either the test has failed or the |
| 42 | # warning may only happen at link time (Clang). In that case, |
| 43 | # make sure the expected symbol is unresolved in the symbol list. |
| 44 | # If so, FORTIFY is working for this case. |
| 45 | if ! $NM -A "$OUT".o | grep -m1 "\bU ${WANT}$" >>"$TMP" ; then |
| 46 | status="warning: unsafe ${FUNC}() usage lacked '$WANT' symbol in $IN" |
| 47 | fi |
| 48 | else |
| 49 | # If the build failed, check for the warning in the stderr (gcc). |
| 50 | if ! grep -q -m1 "error: call to .\b${WANT}\b." "$TMP" ; then |
| 51 | status="warning: unsafe ${FUNC}() usage lacked '$WANT' warning in $IN" |
| 52 | fi |
| 53 | fi |
| 54 | |
| 55 | if [ -n "$status" ]; then |
| 56 | # Report on failure results, including compilation warnings. |
| 57 | echo "$status" | tee "$OUT" >&2 |
| 58 | else |
| 59 | # Report on good results, and save any compilation output to log. |
| 60 | echo "ok: unsafe ${FUNC}() usage correctly detected with '$WANT' in $IN" >"$OUT" |
| 61 | fi |
| 62 | cat "$TMP" >>"$OUT" |